/**
 *  Skript zur Umsetzung der MOBIL_BENUTZER auf WS_AUTH_USER gem.
 *  Anforderung ES (TODO: ???) fr MOBIL XT 1.7.
 *  Erstellt: FB, 11.08.2014
 *  Gltig fr: BALVI iP 1.22 oder hher
 *  Voraussetzung: Der neue S0701-Parameter "WS_AUTH_USER" in der Gruppe "MOBIL" muss existieren.
 *
 *  Alle vorhandenen Benutzer in der S0702 sollen zustzlich den Parameter WS_AUTH_USER zugewiesen bekommen,
 *  wenn dieser noch nicht vorhanden ist.
 *
 */
INSERT INTO VIS_S0702 (ID,S07_ID,S0701_ID,MANDANT,S50_03_SID,WERT,INS_USER,INS_DATE,UPD_USER,UPD_DATE,DELETED)
SELECT
  rawtohex(sys_guid()) AS ID
 ,S0702.S07_ID
 ,(SELECT S0701.ID FROM VIS_S0701 S0701, VIS_S07 S07 WHERE S07.ID = S0701.S07_ID  
                  AND UPPER(S07.CODE)='MOBIL' AND UPPER(S0701.CODE)='WS_AUTH_USER' AND S0701.DELETED=0 AND S07.DELETED = 0) AS S0701_ID
 ,S0702.MANDANT
 ,S0702.S50_03_SID
 ,s0702.WERT
 ,99 AS INS_USER
 ,SYSDATE AS INS_DATE
 ,99 AS UPD_USER
 ,SYSDATE AS UPD_DATE
 ,0 AS DELETED
FROM 
  VIS_S0702 S0702
WHERE
  /* Alle Mobil-Benutzer finden */
  S0702.S0701_ID IN (SELECT S0701.ID FROM VIS_S0701 S0701, VIS_S07 S07 WHERE S07.ID = S0701.S07_ID AND UPPER(S07.CODE)='MOBIL' AND UPPER(S0701.CODE)='MOBIL_BENUTZER' AND S0701.DELETED=0 AND S07.DELETED = 0)
  /* Welche noch nicht WS_AUTH_USER sind */
  AND NOT EXISTS (SELECT NULL FROM VIS_S0702 S0702_P, VIS_S0701 S0701, VIS_S07 S07 WHERE S07.ID = S0701.S07_ID AND S0702_P.S0701_ID = S0701.ID AND S0701.DELETED=0 AND S07.DELETED = 0 
                  AND UPPER(S07.CODE)='MOBIL' AND UPPER(S0701.CODE)='WS_AUTH_USER' AND S0702_P.S50_03_SID = S0702.S50_03_SID)
  /* Neuer Parameter WS_AUTH_USER muss existieren */
  AND (SELECT S0701.ID FROM VIS_S0701 S0701, VIS_S07 S07 WHERE S07.ID = S0701.S07_ID  
                  AND UPPER(S07.CODE)='MOBIL' AND UPPER(S0701.CODE)='WS_AUTH_USER' AND S0701.DELETED=0 AND S07.DELETED = 0) IS NOT NULL
  /* nicht gelscht */
  AND S0702.DELETED = 0
  /* nur aktive Mobil_Benutzer bernehmen ?? */
  AND S0702.WERT = '1'
;