﻿/******************************************************************************

Struktur-Update für BALVI Mobil

$Revision: 945 $
$Date: 2018-06-21 16:00:46 +0200 (Do, 21 Jun 2018) $
$Header: http://svn.balvi.intern/DB-Skripte/trunk/BALVI%20iP/ALTER_JOB_DEF_ERROR_MAIL_ADRESS_BSS35.SQL 945 2018-06-21 14:00:46Z oj@BALVI.INTERN $

******************************************************************************/

DECLARE 
  vCnt INT;
  vIDX_TBS VARCHAR2(50) := NULL; 
  vUI_TBS VARCHAR2(60) := NULL; 
        
  FUNCTION FieldExists(pTable_name IN VARCHAR2, pColumn_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tab_columns
    WHERE table_name = pTable_name
      AND column_name = pColumn_name;
      
    RETURN vCnt > 0; 
  
  END;

  FUNCTION TableExists(pTable_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tables
    WHERE table_name = pTable_name;
      
    RETURN vCnt > 0; 
  
  END;
  
  FUNCTION IdxExists(pIndex_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_indexes
    WHERE index_name = pIndex_Name;
      
    RETURN vCnt > 0; 
  
  END;  

  PROCEDURE COMMENT_COL(pTab_Col IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON COLUMN ' || pTab_Col || ' IS ''' || pComment || '''';  
  END;
  
  PROCEDURE COMMENT_TAB(pTab IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON TABLE ' || pTab || ' IS ''' || pComment || '''';  
  END;
             
BEGIN

  IF NOT FieldExists('JOB_DEF', 'ERROR_MAIL_ADDRESS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE JOB_DEF ADD ERROR_MAIL_ADDRESS VARCHAR2(128)';
    COMMENT_COL('JOB_DEF.ERROR_MAIL_ADDRESS', 'Email Adresse für den Fehlerfall');
  END IF;
  
END;
/

