﻿/******************************************************************************

Struktur-Update für BALVI Mobil

Letzte Änderungen:	12.10.2015
$Revision: 410 $
$Date: 2015-10-15 15:46:26 +0200 (Do, 15 Okt 2015) $
$Header: http://svn.balvi.intern/DB-Skripte/trunk/BALVI%20iP/ALTER_MOBIL_CLIENT_INFOS_181.SQL 410 2015-10-15 13:46:26Z oj@BALVI.INTERN $

******************************************************************************/

DECLARE 
  vCnt INT;
  vIDX_TBS VARCHAR2(50) := NULL; 
  vUI_TBS VARCHAR2(60) := NULL; 
        
  FUNCTION FieldExists(pTable_name IN VARCHAR2, pColumn_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tab_columns
    WHERE table_name = pTable_name
      AND column_name = pColumn_name;
      
    RETURN vCnt > 0; 
  
  END;

  FUNCTION TableExists(pTable_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tables
    WHERE table_name = pTable_name;
      
    RETURN vCnt > 0; 
  
  END;
  
  FUNCTION IdxExists(pIndex_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_indexes
    WHERE index_name = pIndex_Name;
      
    RETURN vCnt > 0; 
  
  END;  

  PROCEDURE COMMENT_COL(pTab_Col IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON COLUMN ' || pTab_Col || ' IS ''' || pComment || '''';  
  END;
  
  PROCEDURE COMMENT_TAB(pTab IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON TABLE ' || pTab || ' IS ''' || pComment || '''';  
  END;
             
BEGIN

  IF NOT FieldExists('MOBIL_CLIENT_INFOS', 'NET_VERSIONS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE MOBIL_CLIENT_INFOS ADD ( NET_VERSIONS VARCHAR2(512))';
  END IF;

  IF NOT FieldExists('MOBIL_CLIENT_INFOS', 'DEVICE') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE MOBIL_CLIENT_INFOS ADD ( DEVICE VARCHAR2(512))';
  END IF;

  IF NOT FieldExists('MOBIL_CLIENT_INFOS', 'LU_ADRESS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE MOBIL_CLIENT_INFOS ADD ( LU_ADRESS VARCHAR2(512))';
  END IF;

  IF NOT FieldExists('MOBIL_CLIENT_INFOS', 'LUI_VERSION') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE MOBIL_CLIENT_INFOS ADD ( LUI_VERSION VARCHAR2(512))';
  END IF;

  IF NOT FieldExists('MOBIL_CLIENT_INFOS', 'LUIS_PORT') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE MOBIL_CLIENT_INFOS ADD ( LUIS_PORT VARCHAR2(512))';
  END IF;


END;
/

