﻿/******************************************************************************

Struktur-Update für BALVI Mobil

$Revision: 653 $
$Date: 2016-11-24 12:14:38 +0100 (Do, 24. Nov 2016) $
$Header: http://svn.balvi.intern/DB-Skripte/trunk/BALVI%20iP/ALTER_XML_EXP_DEF_BSS31.SQL 653 2016-11-24 11:14:38Z oj@BALVI.INTERN $

******************************************************************************/

DECLARE 
  vCnt INT;
  vIDX_TBS VARCHAR2(50) := NULL; 
  vUI_TBS VARCHAR2(60) := NULL; 
        
  FUNCTION FieldExists(pTable_name IN VARCHAR2, pColumn_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tab_columns
    WHERE table_name = pTable_name
      AND column_name = pColumn_name;
      
    RETURN vCnt > 0; 
  
  END;

  FUNCTION TableExists(pTable_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tables
    WHERE table_name = pTable_name;
      
    RETURN vCnt > 0; 
  
  END;
  
  FUNCTION IdxExists(pIndex_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_indexes
    WHERE index_name = pIndex_Name;
      
    RETURN vCnt > 0; 
  
  END;  

  PROCEDURE COMMENT_COL(pTab_Col IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON COLUMN ' || pTab_Col || ' IS ''' || pComment || '''';  
  END;
  
  PROCEDURE COMMENT_TAB(pTab IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON TABLE ' || pTab || ' IS ''' || pComment || '''';  
  END;
             
BEGIN

  IF NOT FieldExists('XML_EXP_DEF', 'DATAPROVIDER_TYPE') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_EXP_DEF ADD DATAPROVIDER_TYPE VARCHAR2(32) DEFAULT ''DPT_JDBC'' NOT NULL';
    COMMENT_COL('XML_EXP_DEF.DATAPROVIDER_TYPE', 'für die xml Generierung – DPT_JDBC oder DPT_REST_JSON');
  END IF;
  
  IF NOT FieldExists('XML_EXP_DEF', 'JDBC_DS_NAME') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_EXP_DEF ADD JDBC_DS_NAME VARCHAR2(64)';
    COMMENT_COL('XML_EXP_DEF.JDBC_DS_NAME', 'JNDI Property Name der Datasource falls DataProvider = DPT_JDBC');
  END IF;
  
  IF NOT FieldExists('XML_EXP_DEF', 'REST_DS_URL_NAME') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_EXP_DEF ADD REST_DS_URL_NAME VARCHAR2(128)';
    COMMENT_COL('XML_EXP_DEF.REST_DS_URL_NAME', 'JNDI Property Name der URL der Datenquelle für Dataprovider = DPT_REST_JSON');
  END IF;


END;
/

