/*<TOAD_FILE_CHUNK>*/

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;
/


ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL = 3;
/

/*
alter session set plsql_warnings = 'Enable:All', 'Disable:(6002, 6006)'; 
alter session set plsql_warnings = 'Disable:All';
*/

/*<TOAD_FILE_CHUNK>*/

CREATE OR REPLACE PACKAGE blv_dms AS
/* 
SVN Revisionsinformationen
$Revision: 415 $
$Date: 2015-10-19 10:06:23 +0200 (Mo, 19 Okt 2015) $  
*/ 

TYPE tDMS_BETRIEB IS RECORD ( 
  ID                             dms_betrieb.ID%TYPE,                                         
  MANDANT                        dms_betrieb.MANDANT%TYPE,
  --INS_USER                       dms_betrieb.INS_USER%TYPE, 
  --INS_DATE                       dms_betrieb.INS_DATE%TYPE, 
  --UPD_USER                       dms_betrieb.UPD_USER%TYPE, 
  --UPD_DATE                       dms_betrieb.UPD_DATE%TYPE, 
  --DELETED                        dms_betrieb.DELETED%TYPE, 
  --DEL_USER                       dms_betrieb.DEL_USER%TYPE, 
  --DEL_DATE                       dms_betrieb.DEL_DATE%TYPE, 
  ERSTELLERKENNUNG               vis_s50.bez%TYPE,
  INSTITUTION                    vis_s50.bez%TYPE,  
  D0101_ID                       dms_betrieb.D0101_ID%TYPE, 
  BETRIEB_FB                     dms_betrieb.BETRIEB_FB%TYPE, 
  BETRIEB_BEZ                    dms_betrieb.BETRIEB_BEZ%TYPE, 
  BETRIEB_NR                     dms_betrieb.BETRIEB_NR%TYPE, 
  BETRIEB_STR                    dms_betrieb.BETRIEB_STR%TYPE, 
  BETRIEB_ORT                    dms_betrieb.BETRIEB_ORT%TYPE, 
  BETRIEB_HAUPTVERANTWORTLICHER  dms_betrieb.BETRIEB_HAUPTVERANTWORTLICHER%TYPE, 
  BETRIEB_ZUL_FLHYG              VARCHAR2(4000), --dms_betrieb.BETRIEB_ZUL_FLHYG%TYPE, 
  BETRIEB_HIT_NR                 vis_d010102.nummer%TYPE, --dms_betrieb.BETRIEB_HIT_NR%TYPE, 
  BETRIEB_LM_HAUPT_BA            VARCHAR2(4000), --dms_betrieb.BETRIEB_LM_HAUPT_BA%TYPE, 
  BETRIEB_LM_BA                  VARCHAR2(4000), --dms_betrieb.BETRIEB_LM_BA%TYPE, 
  BETRIEB_TS_BA                  VARCHAR2(4000), --dms_betrieb.BETRIEB_TS_BA%TYPE, 
  BETRIEB_ANMELDUNG              dms_betrieb.BETRIEB_ANMELDUNG%TYPE, 
  BETRIEB_ABMELDUNG              dms_betrieb.BETRIEB_ABMELDUNG%TYPE, 
  BETREIBER                      dms_betrieb.BETREIBER%TYPE, 
  VERSION_UPDATE                 dms_betrieb.VERSION_UPDATE%TYPE,
  DATE_UPDATE                    dms_betrieb.DATE_UPDATE%TYPE,  
  VERSION_EXPORT                 dms_betrieb.VERSION_EXPORT%TYPE,
  DATE_EXPORT                    dms_betrieb.DATE_EXPORT%TYPE,
  REMOTE_URL                     VIS_S0702.wert%TYPE,
  REMOTE_USER                    VIS_S0702.wert%TYPE,
  REMOTE_PASSW                   vis_s0702.wert%TYPE,
  ServerID                       vis_s0702.wert%TYPE,
  RemoteKonnektorID              vis_s0702.wert%TYPE );

TYPE tbDMS_BETRIEB IS TABLE OF tDMS_BETRIEB;

TYPE tDokument IS RECORD (
    ID                dms_daten.ID%TYPE
  , MANDANT           dms_daten.MANDANT%TYPE
  , ERSTELLERKENNUNG  vis_s50.bez%TYPE
  , INSTITUTION       vis_s50.bez%TYPE
  --, INS_USER          dms_daten.INS_USER%TYPE
  --, INS_DATE          dms_daten.INS_DATE%TYPE
  --, UPD_USER          dms_daten.UPD_USER%TYPE
  --, UPD_DATE          dms_daten.UPD_DATE%TYPE
  , DELETED           dms_daten.DELETED%TYPE
  --, DEL_USER          dms_daten.DEL_USER%TYPE
  --, DEL_DATE          dms_daten.DEL_DATE%TYPE
  , DMS_BETRIEB_ID    dms_daten.DMS_BETRIEB_ID%TYPE
  , D0101_ID          dms_daten.D0101_ID%TYPE
  , D0303_ID          dms_daten.D0303_ID%TYPE
  , D030301_ID        dms_daten.D030301_ID%TYPE
  , DMS_OBJ_ID        vis_d030301.DMS_OBJ_ID%TYPE
  , DOK_OBJEKT_CODE   dms_daten.DOK_OBJEKT_CODE%TYPE
  , DOK_OBJEKT_BEZ    dms_daten.DOK_OBJEKT_BEZ%TYPE
  , DOK_BEZ           dms_daten.DOK_BEZ%TYPE
  , DOK_INS_DATE      dms_daten.DOK_INS_DATE%TYPE
  , DOK_FB            dms_daten.DOK_FB%TYPE
  , FILETYPE          vis_d0303.filetype%TYPE
  , REF_ID            dms_daten.REF_ID%TYPE
  , DATUM             dms_daten.DATUM%TYPE
  , ART               dms_daten.ART%TYPE
  , PROBE_NR          dms_daten.PROBE_NR%TYPE
  , PROBE_BEZ         dms_daten.PROBE_BEZ%TYPE
  , UEBERWACHER       dms_daten.UEBERWACHER%TYPE
  , VERANTWORTLICHER  dms_daten.VERANTWORTLICHER%TYPE
  , CONTENT           vis_d0303.content%TYPE
  , VERSION_UPDATE    dms_daten.VERSION_UPDATE%TYPE
  , DATE_UPDATE       dms_daten.DATE_UPDATE%TYPE
  , VERSION_EXPORT    dms_daten.VERSION_EXPORT%TYPE
  , DATE_EXPORT       dms_daten.DATE_EXPORT%TYPE
  , REMOTE_URL        VIS_S0702.wert%TYPE
  , REMOTE_USER       VIS_S0702.wert%TYPE
  , REMOTE_PASSW      vis_s0702.wert%TYPE
  , ServerID          vis_s0702.wert%TYPE
  , RemoteKonnektorID vis_s0702.wert%TYPE );

TYPE tbDokument IS TABLE OF tDokument;

TYPE tRemoteParams IS RECORD (
  MANDANT           vis_s50.sid%TYPE,
  REMOTE_URL        VIS_S0702.wert%TYPE,
  REMOTE_USER       VIS_S0702.wert%TYPE,
  REMOTE_PASSW      vis_s0702.wert%TYPE,
  ServerId          vis_s0702.wert%TYPE,
  RemoteKonnektorID vis_s0702.wert%TYPE );
TYPE tbRemoteParams IS TABLE OF tRemoteParams;  
 
SUBTYPE tID32 IS VARCHAR2(32 CHAR); 
SUBTYPE tVarcharMax IS VARCHAR2(4000 CHAR);

TYPE tExport IS RECORD (
  ID tID32,
  OBJ VARCHAR2(3),
  INS_DATE DATE );
  
TYPE tbExport IS TABLE OF tExport;  
   
PROCEDURE Betriebsakte(pD0101_ID IN VARCHAR2, pErst IN PLS_INTEGER, pCommit IN INTEGER := 1);
PROCEDURE Betriebsakte(pD0101_ID IN VARCHAR2);
PROCEDURE Dokument(pD0303_ID IN VARCHAR2);
FUNCTION BetriebsakteExport(pD0101_ID IN VARCHAR2 := NULL, pForce IN INTEGER := 0) RETURN tbDMS_BETRIEB PIPELINED;
FUNCTION BetriebsakteConfirm(pD0101_ID IN VARCHAR2, pVersion_Update IN INTEGER, pDMS_Obj_ID IN VARCHAR2) RETURN INTEGER; 
FUNCTION DokumentConfirm(pDMS_Daten_ID IN VARCHAR2, pVersion_Update IN INTEGER, pDMS_Obj_ID IN VARCHAR2, pDeleteDok IN INTEGER := 1) RETURN INTEGER;
FUNCTION DokumentExport(pDMS_DATEN_ID IN VARCHAR2 := NULL, pForce IN INTEGER := 0) RETURN tbDokument PIPELINED;
FUNCTION RemoteParams(pMandant_SID IN INTEGER) RETURN tbRemoteParams PIPELINED;
FUNCTION ChkMandantDMS(pMandant_SID IN INTEGER) RETURN INTEGER DETERMINISTIC;
PROCEDURE BetriebsakteErstbefuellung(pLimit IN INTEGER := 1000);
PROCEDURE DokumentErstbefuellung(pLimit IN INTEGER := 1000);
FUNCTION Dokument(pD0303_ID IN VARCHAR2) RETURN VARCHAR;
PROCEDURE Dokument(pD0303_ID IN VARCHAR2, pResult OUT NOCOPY VARCHAR2, pErst IN PLS_INTEGER);
FUNCTION GetExportIDS(pErst IN PLS_INTEGER) RETURN tbExport PIPELINED;
END blv_dms;
/

/*<TOAD_FILE_CHUNK>*/
CREATE OR REPLACE PACKAGE BODY blv_dms AS

PROCEDURE Betriebsakte(pD0101_ID IN VARCHAR2) AS
BEGIN
  Betriebsakte(pD0101_ID, 0, 1 );  
END;

/** 
  Betrieb fr DMS bereitstellen bzw. aktualisieren
  pD0101_ID : vis_d0101.id
  pErst : 1 - Erstbefllung
**/
PROCEDURE Betriebsakte(pD0101_ID IN VARCHAR2, pErst IN PLS_INTEGER, pCommit IN INTEGER := 1 ) AS
vBts dms_betrieb%ROWTYPE;
vD0101 vis_d0101%ROWTYPE;
vSYSDATE DATE := SYSDATE;
vUser_SID PLS_INTEGER := BLV_SYS.GET_USER_SID;
BEGIN

  SELECT * 
  INTO vD0101 
  FROM vis_d0101 WHERE id = pD0101_ID;

  IF vD0101.skz = 1 THEN
    BEGIN
      SELECT * INTO vBts
      FROM dms_betrieb WHERE d0101_id = pD0101_ID
      FOR UPDATE;

      vBTS.Version_Update := vBts.Version_Update + 1;
      
      EXCEPTION WHEN NO_DATA_FOUND THEN 
        vBts.id := '-9999';
        vBts.INS_USER := vUser_SID; 
        vBts.INS_DATE := vSYSDATE;
        vBts.D0101_ID := pD0101_ID;
        vBTS.version_update := 0;
        vBTS.date_update := vSysdate;
        vBts.version_export := -1;
    END;
    
    vBts.MANDANT := vD0101.mandant; 
    vBts.UPD_USER := vUSER_SID;
    vBts.UPD_DATE := vSYSDATE;
    vBts.DELETED  := 0;
    vBts.DEL_USER := -1;
    vBts.DEL_DATE := NULL;
    vBts.BETRIEB_FB := vD0101.fachb;
    vBts.BETRIEB_BEZ := vD0101.bez 
               || CASE WHEN vD0101.bez IS NOT NULL AND vD0101.name1 IS NOT NULL THEN ' / '
               END || vD0101.name1;
    vBts.BETRIEB_NR := vD0101.code;
    vBts.BETRIEB_STR := TRIM (vD0101.strasse || ' ' || TRIM (vD0101.hausnr || ' ' || vD0101.hausnrzusatz)); 
    vBts.BETRIEB_ORT := RTRIM(vD0101.plz || ' ' || vD0101.ort || ' ' || vD0101.ortsteil);
    vBts.BETRIEB_ANMELDUNG := vD0101.anmeldung;
    vBts.BETRIEB_ABMELDUNG := vD0101.abmeldung;

    IF pErst = 1 THEN
      vBts.version_export := -2;
    END IF;
    
    IF vD0101.id = vD0101.d0101_id3 THEN
      vBTS.BETREIBER := vD0101.bez;
    ELSE
      SELECT dx.bez --|| CASE WHEN dx.bez IS NOT NULL AND dx.name1 IS NOT NULL THEN ' / '
      --END || dx.name1
      INTO vBts.BETREIBER 
      FROM vis_d0101 dx WHERE dx.id = vD0101.d0101_id3;
    END IF;
    
    -- 18.12.2014 wird beim Export verarbeitet
    IF vD0101.d010200_id2 = '-1' THEN -- HV definiert
      vBts.BETRIEB_HAUPTVERANTWORTLICHER := NULL;
    ELSE
      SELECT NVL(d010200.bez, d0102.bez) INTO vBts.BETRIEB_HAUPTVERANTWORTLICHER 
      FROM vis_d010200 d010200
      JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
      WHERE d010200.id = vD0101.D010200_id2;    
    END IF;
    
    IF vBts.id = '-9999' THEN -- noch nicht vorhanden -> anlegen
      vBts.id := SYS_GUID();
      INSERT INTO dms_betrieb VALUES vBts;
    ELSE
      UPDATE dms_betrieb
      SET row = vBts 
      WHERE id = vBts.id;    
    END IF;
    
    IF pCommit = 1 THEN
      COMMIT;
    END IF;
  END IF; -- skz = 1
END Betriebsakte;


PROCEDURE RemoteParams (
    pS50_SID IN NUMBER
  , pURL OUT NOCOPY VARCHAR2
  , pUser OUT NOCOPY VARCHAR2
  , pPassw OUT NOCOPY VARCHAR2
  , pServerId OUT NOCOPY VARCHAR2
  , pRemoteKonnektorID OUT NOCOPY VARCHAR2 ) DETERMINISTIC AS
BEGIN
 
  BEGIN
    SELECT S0702_URL.WERT AS REMOTE_URL
     ,S0702_USER.WERT AS REMOTE_USER
     ,S0702_PASS.WERT AS REMOTE_PASS
     ,s0702_ServerID.wert AS ServerId 
     , s0702_KonnId.wert AS KonnId
    INTO pURL, pUSER, pPASSW, pServerId, pRemoteKonnektorID
    FROM VIS_S07 S07

    JOIN VIS_S0701 S0701_URL ON s07.id = s0701_URL.s07_id 
    AND S0701_URL.DELETED = 0 AND UPPER(S0701_URL.CODE) = 'REMOTEURL'
    JOIN VIS_S0702 S0702_URL ON S0702_URL.s0701_id = s0701_URL.id 
    AND s0702_url.mandant = pS50_sid

    JOIN VIS_S0701 S0701_user ON s0701_user.s07_id = s07.id 
    AND S0701_user.DELETED = 0 AND UPPER(S0701_user.CODE) = 'REMOTEUSER'
    JOIN VIS_S0702 S0702_USER ON s0702_user.s0701_id = s0701_user.id
    AND s0702_user.deleted = 0
    AND s0702_user.mandant = pS50_sid

    JOIN VIS_S0701 S0701_pass ON s0701_pass.s07_id = s07.id 
    AND S0701_pass.DELETED = 0 AND UPPER(S0701_pass.CODE) = 'REMOTEPASSWORD'
    JOIN VIS_S0702 S0702_pass ON s0702_pass.s0701_id = s0701_pass.id
    AND s0702_pass.deleted = 0
    AND s0702_pass.mandant = pS50_sid

    JOIN VIS_S0701 S0701_ServerID ON S0701_ServerID.s07_id = s07.id 
    AND S0701_ServerID.DELETED = 0 AND UPPER(S0701_ServerID.CODE) = 'SERVERID'
    JOIN VIS_S0702 S0702_ServerID ON s0702_ServerID.s0701_id = s0701_ServerID.id
    AND s0702_ServerID.deleted = 0
    AND s0702_ServerID.mandant = pS50_sid

    JOIN VIS_S0701 S0701_KonnID ON S0701_KonnID.s07_id = s07.id 
    AND S0701_KonnID.DELETED = 0 AND UPPER(S0701_KonnID.CODE) = 'REMOTEKONNEKTORID'
    JOIN VIS_S0702 S0702_KonnID ON s0702_KonnID.s0701_id = S0701_KonnID.id
    AND s0702_KonnID.deleted = 0
    AND s0702_KonnID.mandant = pS50_sid

    WHERE S07.DELETED = 0 AND S07.CODE = 'DMS';
    
    EXCEPTION WHEN NO_DATA_FOUND THEN 
      pURL := NULL;    
      pUSER := NULL;    
      pPassw := NULL;
      pServerID := NULL;
      pRemoteKonnektorID := NULL;    
    
  END;
END RemoteParams; 

FUNCTION RemoteParams(pMandant_SID IN INTEGER) RETURN tbRemoteParams PIPELINED AS
v tRemoteParams;
BEGIN
  v.mandant := pMandant_sid;
  RemoteParams(v.mandant, v.REMOTE_URL, v.REMOTE_USER, v.REMOTE_PASSW, v.ServerId, v.RemoteKonnektorID);
  PIPE ROW(v);  
  RETURN;
END RemoteParams;

FUNCTION ChkMandantDMS(pMandant_SID IN INTEGER) RETURN INTEGER DETERMINISTIC AS
vRes PLS_INTEGER := 0;
BEGIN

    SELECT COUNT(*) INTO vRes
    FROM VIS_S07 S07
    JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
    AND UPPER(S0701.CODE) LIKE 'DMSMODE'
    AND s0701.deleted = 0
    JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id
    AND s0702.deleted = 0
    AND s0702.wert = '1'
    AND s0702.mandant = pMandant_SID
    AND S07.DELETED = 0 AND S07.CODE = 'DMS'
    AND ROWNUM = 1;  

  RETURN vRes;
END ChkMandantDMS;

-- Aufbereiten und zurckgeben der Betriebsakte 
-- pD0101_ID : vis_d0101.id
FUNCTION BetriebsakteExport(pD0101_ID IN VARCHAR2 := NULL, pForce IN INTEGER := 0) RETURN tbDMS_BETRIEB PIPELINED AS
vBTS tDMS_BETRIEB;
vD0101 vis_d0101%ROWTYPE;
vBTS0 DMS_BETRIEB%ROWTYPE;
vSYSDATE DATE := SYSDATE;
TYPE tID IS RECORD ( ID tID32 );
TYPE tbIDs IS TABLE OF tID; 
vD0101_IDs tbIDs := tbIDs();
BEGIN
  
  CASE
  WHEN pD0101_ID IS NULL AND pForce = 0 THEN
    SELECT bts.d0101_id
    BULK COLLECT INTO vD0101_IDs
    FROM dms_betrieb bts
    WHERE bts.version_update > bts.version_export
    ORDER BY bts.date_update;
  
  WHEN pD0101_ID IS NULL AND pForce > 0 THEN
    SELECT bts.d0101_id
    BULK COLLECT INTO vD0101_IDs
    FROM dms_betrieb bts
    ORDER BY bts.date_update;
  
  WHEN pD0101_ID IS NOT NULL AND pForce = 0 THEN
    SELECT bts.d0101_id
    BULK COLLECT INTO vD0101_IDs
    FROM dms_betrieb bts
    WHERE bts.d0101_id = pD0101_id
    AND bts.version_update > bts.version_export;

  WHEN pD0101_ID IS NOT NULL AND pForce > 0 THEN
    SELECT bts.d0101_id
    BULK COLLECT INTO vD0101_IDs
    FROM dms_betrieb bts
    WHERE bts.d0101_id = pD0101_id;
  
  ELSE NULL;
  END CASE;
 
  IF vD0101_IDs.COUNT > 0 THEN
        
    FOR iD0101_ID IN vD0101_IDs.FIRST .. vD0101_IDs.LAST LOOP

      vBts.REMOTE_URL := NULL;    
      vBts.REMOTE_USER := NULL;    
      vBts.REMOTE_PASSW := NULL;
      vBts.ServerID := NULL;
      vBts.RemoteKonnektorID := NULL;

      BEGIN
        SELECT * 
        INTO vBts0
        FROM dms_betrieb WHERE d0101_id = vD0101_IDs(iD0101_ID).id;

        RemoteParams(vBts0.mandant, vBts.REMOTE_URL, vBts.REMOTE_USER, vBts.REMOTE_PASSW, vBts.ServerId, vBts.RemoteKonnektorID);

        EXCEPTION WHEN NO_DATA_FOUND THEN 
          vBTS0.id := NULL;         
      END;
      
      IF vBTS0.id IS NOT NULL THEN

        SELECT * 
        INTO vD0101 
        FROM vis_d0101 WHERE id = vD0101_IDs(iD0101_ID).id;
        
        vBTS.ID           := vBTS0.id;
        vBTS.d0101_id     := vBTS0.d0101_id;
        vBts.MANDANT      := vBTS0.mandant;
        vBTS.Erstellerkennung := NULL;
        
        SELECT MAX(s50.bez) INTO vBTS.Erstellerkennung
        FROM vis_s50 s50
        WHERE s50.sid = vD0101.upd_user;
  

        SELECT MAX(s50.bez) INTO vBTS.INSTITUTION
        FROM vis_s50 s50 WHERE s50.sid = vBTS0.mandant;          
        
        --vBts.UPD_USER     := vBTS0.UPD_USER;
        --vBts.UPD_DATE     := vBTS0.UPD_DATE;
        --vBts.DELETED      := vBTS0.DELETED;
        --vBts.DEL_USER     := vBTS0.DEL_USER;
        --vBts.DEL_DATE     := vBTS0.DEL_DATE;
        vBts.BETRIEB_FB   := vBTS0.BETRIEB_FB;
        vBts.BETRIEB_BEZ  := vBTS0.BETRIEB_BEZ;
        vBts.BETRIEB_NR   := vBTS0.BETRIEB_NR;
        vBts.BETRIEB_STR  := vBTS0.BETRIEB_STR; 
        vBts.BETRIEB_ORT  := vBTS0.BETRIEB_ORT;
        vBts.BETRIEB_ANMELDUNG  := vBTS0.BETRIEB_ANMELDUNG;
        vBts.BETRIEB_ABMELDUNG  := vBTS0.BETRIEB_ABMELDUNG;
        vBTS.BETREIBER          := vBTS0.BETREIBER;
        
        CASE 
        WHEN vD0101.d010200_id2 = '-1' THEN
          vBTS.BETRIEB_HAUPTVERANTWORTLICHER := NULL;
          
        WHEN vBTS0.BETRIEB_HAUPTVERANTWORTLICHER IS NULL THEN
        
          SELECT d0102.bez INTO vBts.BETRIEB_HAUPTVERANTWORTLICHER 
          FROM vis_d010200 d010200
          JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id
          WHERE d010200.id = vD0101.D010200_id2; 
          
        ELSE
          vBTS.BETRIEB_HAUPTVERANTWORTLICHER := vBTS0.BETRIEB_HAUPTVERANTWORTLICHER;
        END CASE;
        vBTS.VERSION_UPDATE := vBTS0.VERSION_UPDATE;
        vBTS.DATE_UPDATE    := vBTS0.DATE_UPDATE;
        vBTS.VERSION_EXPORT := vBTS0.VERSION_EXPORT; 
        vBTS.DATE_EXPORT    := vBTS0.DATE_EXPORT;

        -- Zulassungen Fleischhygiene  
        vBts.BETRIEB_ZUL_FLHYG := NULL;
        FOR c1 IN (
          SELECT dx.nummer
          FROM vis_vd010102 dx 
          WHERE dx.a010145_skz = 60 
          AND (dx.a010145_code LIKE '0103%' OR dx.a010145_code LIKE '010111%')
          AND dx.a010145_kz = 'Z'
          AND dx.nummer IS NOT NULL
          AND dx.d0101_id = vD0101_IDs(iD0101_ID).id
        ) LOOP
          vBts.BETRIEB_ZUL_FLHYG := vBts.BETRIEB_ZUL_FLHYG || c1.nummer || ';';
        END LOOP;
        vBts.BETRIEB_ZUL_FLHYG := RTRIM(vBts.BETRIEB_ZUL_FLHYG, ';');  
        
        SELECT MAX(d010102.NUMMER) KEEP ( DENSE_RANK FIRST ORDER BY d010102.gueltig_bis DESC) 
        INTO vBts.BETRIEB_HIT_NR                  
         FROM VIS_VD010102 d010102 
         WHERE d010102.DELETED > -2 
           AND d010102.a010145_code = '0102' 
           AND d010102.a010145_skz = 10
         AND d010102.d0101_id = vD0101_IDs(iD0101_ID).id; 
              
        vBts.BETRIEB_LM_HAUPT_BA := NULL;
        vBts.BETRIEB_LM_BA := NULL;
        vBts.BETRIEB_TS_BA := NULL;

        FOR c1 IN (
          SELECT a010108.bez, a010108.skz, d010101.hauptn, a010108.fb
          FROM vis_d010101 d010101 
          JOIN vis_a010108 a010108 ON a010108.sid = d010101.a010108_sid
          AND d010101.deleted = 0
          AND d010101.aktiv = 1
          AND d010101.gueltig_bis > vSYSDATE
          AND d010101.d0101_id = vD0101_IDs(iD0101_ID).id
          AND a010108.skz IN( 1, 2)
          AND (a010108.fb LIKE '%H%' OR a010108.fb LIKE '%D%')
        ) LOOP
        
          CASE
          WHEN c1.skz = 2 AND c1.hauptn = 1 THEN 
            vBts.BETRIEB_LM_HAUPT_BA := c1.bez;
          WHEN c1.skz = 2 AND c1.fb LIKE '%H%' THEN
            vBts.BETRIEB_LM_BA := SUBSTR(vBts.BETRIEB_LM_BA || c1.bez || ';', 1, 4000);  
          WHEN c1.skz = 1 AND c1.fb LIKE '%D%' THEN 
            vBts.BETRIEB_TS_BA := SUBSTR(vBts.BETRIEB_TS_BA || c1.bez || ';', 1, 4000);  
          ELSE NULL;
          END CASE; 
            
        END LOOP;
        vBts.BETRIEB_LM_BA := RTRIM(vBts.BETRIEB_LM_BA, ';');  
        vBts.BETRIEB_TS_BA := RTRIM(vBts.BETRIEB_TS_BA, ';');     
        
    --    IF pConfirm = 1 THEN
    --      UPDATE dms_betrieb
    --      SET version_export = version_update
    --      WHERE d0101_id = vD0101_IDs(iD0101_ID).id;
    --      COMMIT;
    --    END IF;    
            
        PIPE ROW(vBts);
        
      END IF;
    END LOOP;  
  END IF;
  RETURN;
END BetriebsakteExport;

-- Erfolgreichen Export der Betriebsakte einer Version besttigen
-- Rckgabe_
--  0 : nicht erfolgreich
--  1 : erfolgreich
--  2 : erfolgreich und neue Version fr den Export liegt vor
FUNCTION BetriebsakteConfirm(pD0101_ID IN VARCHAR2, pVersion_Update IN INTEGER, pDMS_Obj_ID IN VARCHAR2) RETURN INTEGER AS
vRes PLS_INTEGER := 0;
vVersion_Update dms_betrieb.version_update%TYPE;
vSysdate DATE := SYSDATE; 
BEGIN
  UPDATE dms_betrieb
  SET version_export = pVersion_Update
    , date_export = vSysdate
  WHERE d0101_id = pD0101_ID
  AND version_update >= pVersion_update
  RETURNING version_update INTO vVersion_Update;

  IF SQL%ROWCOUNT > 0 THEN
    IF vVersion_Update = pVersion_Update THEN
      vRes := 1;
    ELSE
      vRes := 2;
    END IF;   
  END IF;
  
  IF pDMS_Obj_ID IS NOT NULL THEN
    UPDATE vis_d0101
    SET dms_obj_id = pDMS_OBJ_ID
      , upd_date = vSYSDATE
    WHERE id = pD0101_ID;
  END IF;
  
  RETURN vRes;
END BetriebsakteConfirm;

-- Erfolgreichen Export eiens Dokuments einer Version besttigen
-- Rckgabe_
--  0 : nicht erfolgreich
--  1 : erfolgreich
--  2 : erfolgreich und neue Version fr den Export liegt vor
FUNCTION DokumentConfirm(pDMS_Daten_ID IN VARCHAR2, pVersion_Update IN INTEGER, pDMS_Obj_ID IN VARCHAR2, pDeleteDok IN INTEGER := 1) RETURN INTEGER AS
vRes PLS_INTEGER := 0;
vVersion_Update dms_daten.version_update%TYPE;
vSysdate DATE := SYSDATE; 
vD0303_id dms_daten.d0303_id%TYPE;
vD030301_id dms_daten.d030301_id%TYPE;
vUpdD0303 BOOLEAN := FALSE;
BEGIN
  UPDATE dms_daten
  SET version_export = pVersion_Update
    , date_export = vSysdate
  WHERE id = pDMS_Daten_ID
  AND version_update >= pVersion_update
  RETURNING version_update, d0303_id, d030301_id INTO vVersion_Update, vD0303_id, vD030301_id;

  IF SQL%ROWCOUNT > 0 THEN
    IF vVersion_Update = pVersion_Update THEN
      vRes := 1;
      IF pDeleteDok = 1 THEN
        UPDATE vis_d0303
        SET upd_date = vSysdate
          , content = NULL
          , dms_obj_id = pDms_Obj_ID
        WHERE id = vD0303_id;
        vUpdD0303 := TRUE;
      END IF;
    ELSE
      vRes := 2;
    END IF;   

    IF NOT vUpdD0303 THEN
      UPDATE vis_d0303
      SET upd_date = vSysdate
        , dms_obj_id = pDms_Obj_ID
      WHERE id = vD0303_id;
    END IF;
    
    UPDATE vis_d030301
    SET upd_date = vSysdate
      , dms_obj_id = pDms_Obj_ID
    WHERE id = vD030301_id;
  END IF;
  
  RETURN vRes;
END DokumentConfirm;

/*
Frage:
Wie muss d030301 verarbeitet werden? Ist nur fr Serienbriefe relevant - Aussage RB
Wo stehen die Betriebe und wo ist das Objekt geapeichert?
*/

FUNCTION DokumentExport(pDMS_DATEN_ID IN VARCHAR2 := NULL, pForce IN INTEGER := 0) RETURN tbDokument PIPELINED AS
TYPE tID IS RECORD ( ID tID32 );
TYPE tbIDs IS TABLE OF tID; 
vIDs tbIDs := tbIDs();
v tDokument;
BEGIN

  CASE
  WHEN pDMS_DATEN_ID IS NULL AND pForce = 0 THEN
    SELECT d1.id
    BULK COLLECT INTO vIDs
    FROM dms_daten d1
    WHERE d1.version_update > d1.version_export
    ORDER BY d1.date_update;
 
  WHEN pDMS_DATEN_ID IS NULL AND pForce > 0 THEN
    SELECT d1.id
    BULK COLLECT INTO vIDs
    FROM dms_daten d1
    ORDER BY d1.date_update;
 
  WHEN pDMS_DATEN_ID IS NOT NULL AND pForce = 0 THEN
    SELECT d1.id
    BULK COLLECT INTO vIDs
    FROM dms_daten d1
    WHERE d1.id = pDMS_DATEN_ID
    AND d1.version_update > d1.version_export;

  WHEN pDMS_DATEN_ID IS NOT NULL AND pForce > 0 THEN
    SELECT d1.id
    BULK COLLECT INTO vIDs
    FROM dms_daten d1
    WHERE d1.id = pDMS_DATEN_ID;
  
  ELSE NULL;
  END CASE;

  IF vIDs.COUNT > 0 THEN
        
    FOR iID IN vIDs.FIRST .. vIDs.LAST LOOP

      v.REMOTE_URL := NULL;    
      v.REMOTE_USER := NULL;    
      v.REMOTE_PASSW := NULL;
      v.ServerID := NULL;
      v.RemoteKonnektorID := NULL;

      BEGIN
     
        SELECT 
          d1.ID                
        , d1.MANDANT
        , (SELECT s50.bez FROM vis_s50 s50 WHERE s50.sid = d0303.ins_user) ERSTELLERKENNUNG 
        , (SELECT s50.bez FROM vis_s50 s50 WHERE s50.sid = d0303.mandant) INSTITUTION        
        --, d1.INS_USER          
        --, d1.INS_DATE          
        --, d1.UPD_USER          
        --, d1.UPD_DATE          
        , d1.DELETED           
        --, d1.DEL_USER          
        --, d1.DEL_DATE          
        , d1.DMS_BETRIEB_ID    
        , d1.D0101_ID          
        , d1.D0303_ID          
        , d1.D030301_ID
        , d030301.dms_obj_id        
        , d1.DOK_OBJEKT_CODE   
        , d1.DOK_OBJEKT_BEZ    
        , d1.DOK_BEZ           
        , d1.DOK_INS_DATE      
        , d1.DOK_FB            
        , d1.REF_ID            
        , d1.DATUM             
        , d1.ART               
        , d1.PROBE_NR          
        , d1.PROBE_BEZ         
        , d1.UEBERWACHER       
        , d1.VERANTWORTLICHER  
        , d0303.CONTENT   
        , d0303.filetype        
        , d1.VERSION_UPDATE    
        , d1.DATE_UPDATE       
        , d1.VERSION_EXPORT    
        , d1.DATE_EXPORT       
        INTO 
          v.ID              
        , v.MANDANT 
        , v.ERSTELLERKENNUNG 
        , v.INSTITUTION                  
        --, v.INS_USER          
        --, v.INS_DATE          
        --, v.UPD_USER          
        --, v.UPD_DATE          
        , v.DELETED           
        --, v.DEL_USER          
        --, v.DEL_DATE          
        , v.DMS_BETRIEB_ID    
        , v.D0101_ID          
        , v.D0303_ID          
        , v.D030301_ID   
        , v.dms_obj_id     
        , v.DOK_OBJEKT_CODE   
        , v.DOK_OBJEKT_BEZ    
        , v.DOK_BEZ           
        , v.DOK_INS_DATE      
        , v.DOK_FB            
        , v.REF_ID            
        , v.DATUM             
        , v.ART               
        , v.PROBE_NR          
        , v.PROBE_BEZ         
        , v.UEBERWACHER       
        , v.VERANTWORTLICHER  
        , v.CONTENT        
        , v.FileType   
        , v.VERSION_UPDATE    
        , v.DATE_UPDATE       
        , v.VERSION_EXPORT    
        , v.DATE_EXPORT        
        FROM dms_daten d1
        JOIN vis_d0303 d0303 ON d0303.id = d1.d0303_id
        JOIN vis_d030301 d030301 ON d030301.id = d1.d030301_id
        WHERE d1.id = vIDs(iID).id;

        RemoteParams(v.mandant, v.REMOTE_URL, v.REMOTE_USER, v.REMOTE_PASSW, v.ServerId, v.RemoteKonnektorId);

        EXCEPTION WHEN NO_DATA_FOUND THEN 
          v.id := NULL;         
      END;
      IF v.id IS NOT NULL THEN    
        PIPE ROW(v);
      END IF;
    END LOOP;
  END IF;
  RETURN;
END DokumentExport;

/** 
  Dokument fr DMS bereitstellen bzw. aktualisieren
  pD0303_ID : vis_d0303.id
  pResult : OK - ohne Fehler, sonst Fehlermeldung
  pErst : 1 - Erstbefllung
**/
PROCEDURE Dokument(pD0303_ID IN VARCHAR2, pResult OUT NOCOPY VARCHAR2, pErst IN PLS_INTEGER) AS
vDaten dms_daten%ROWTYPE;

TYPE tD0303 IS RECORD (
  id vis_d0303.id%TYPE,
  bez vis_d0303.bez%TYPE,
  s5200_sid vis_d0303.s5200_sid%TYPE,
  ref_id vis_d0303.ref_id%TYPE,
  ref_obj vis_d0303.ref_obj%TYPE,
  s1711_sid vis_d0303.s1711_sid%TYPE,
  mandant vis_d0303.mandant%TYPE,
  ins_date vis_d0303.ins_date%TYPE,
  CONTENT_LENGTH PLS_INTEGER,
  filetype vis_d0303.filetype%TYPE,
  dok_objekt_code vis_s5200.code%TYPE,
  dok_objekt_bez vis_s5200.bez%TYPE,
  s5200_fb vis_s5200.fb%TYPE
   );
vD0303 tD0303;
  
TYPE tD030301 IS TABLE OF vis_d030301%ROWTYPE;
vD030301 tD030301;
vD030301_ID vis_d030301.id%TYPE;
vD0101_ID vis_d030301.d0101_id%TYPE;
vFB VARCHAR2(50);
--vS5200_FB vis_s5200.fb%TYPE;
vSYSDATE DATE := SYSDATE;
vRes_ok CONSTANT VARCHAR2(2) := 'OK';
BEGIN

  pResult := NULL;
  
  SELECT d0303.id, d0303.bez, d0303.s5200_sid, d0303.ref_id
  , UPPER(d0303.ref_obj), d0303.s1711_sid, d0303.mandant
  , d0303.ins_date, LENGTH(d0303.content), d0303.filetype
  , s5200.code, s5200.bez, s5200.fb
  INTO vD0303 
  FROM vis_d0303 d0303
  JOIN vis_s5200 s5200 ON s5200.sid = 
    CASE WHEN d0303.s5200_sid = 1107001 AND UPPER(d0303.ref_obj) IN( 'VIS_D010801', 'VIS_D011301') THEN 60001  -- 1.08.04, beim Import wird VIS_D010801 gesetzt
    ELSE d0303.s5200_sid END --1.13.01
  AND d0303.id = pD0303_ID; 

  CASE
  WHEN vD0303.Filetype = 'SCAN' THEN
    pResult := vRes_ok;
  WHEN NVL(vD0303.content_length, 0) = 0 THEN
    pResult := 'Das Dokumemnt ist leer.';
  WHEN REGEXP_SUBSTR(vD0303.FILETYPE,'^DO(C|T)(X)?$|^XLS(X|M)?$|JP(E)?G|RTF|TXT|PDF|CSV|PNG|BMP',1,1,'i') IS NULL THEN
    pResult := 'Das Dokument enthlt einen ungltigen Dateityp "'|| vD0303.FILETYPE || '".'; 
  ELSE pResult := vRes_ok;
  END CASE;

  IF pResult = vRes_ok THEN
  
    SELECT *
    BULK COLLECT INTO vD030301
    FROM vis_d030301
    WHERE deleted = 0
    AND d0303_id = pD0303_id
    ORDER BY CASE WHEN d0101_id = '-1' THEN 1 ELSE 0 END; -- '-1' steht am Ende

    -- wenn mehr als ein DS dann letzten -1 lschen
    -- bei Serienbriefen ist d0303.d0101_id = '-1' und 
    -- ein d030301.d0101_id = '-1'
    -- alle Betriebe stehen immer in d030301.d0101_id
    -- wenn kein Serienbrief enthlt auch d0303.d0101_id den Betrieb
    CASE
    WHEN vD030301.COUNT > 1 AND vD030301(vD030301.LAST).d0101_id = '-1' THEN
      vD030301.DELETE(vD030301.LAST);
    WHEN vD030301.COUNT = 1 AND vD030301(1).d0101_id = '-1' THEN
      -- Brgerbeschwerden, Vergtungen, Weitere Ttigkeiten Eingenbehrde
      IF vD0303.ref_obj IN ('VIS_D0114', 'VIS_D030502') OR vD0303.dok_objekt_code = '1.08.05_2' THEN
        NULL; --OK
      ELSE -- Dokument ohne Betrieb    
        vD030301.DELETE;
      END IF;
    WHEN vD030301.COUNT = 0 THEN
      pResult := 'Dem Dokument ist kein Betrieb zugeordnet.';   
    ELSE NULL;  
    END CASE; 
 
    IF vD030301.COUNT > 0 THEN
      FOR IdxD030301 IN vD030301.FIRST .. vD030301.LAST LOOP
        vD030301_ID := vD030301(IdxD030301).id;
        vD0101_ID := vD030301(IdxD030301).d0101_id;
        
        BEGIN
          SELECT * INTO vDaten
          FROM dms_daten WHERE d030301_id = vD030301_ID
          FOR UPDATE;
          
          EXCEPTION WHEN NO_DATA_FOUND THEN 
            vDaten.id := '-9999';
            vDaten.INS_USER := BLV_SYS.GET_USER_SID; 
            vDaten.INS_DATE := vSYSDATE;
            vDaten.Version_Update := -1;
            vDaten.Version_Export := -1;
        END; 
        
        IF vD0101_ID <> '-1' THEN -- kein Betrieb
          BEGIN
            SELECT id INTO vDaten.DMS_BETRIEB_ID
            FROM dms_betrieb
            WHERE d0101_id = vD0101_id;
          
            EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
              Betriebsakte(vD0101_id, pErst);
             
             BEGIN            
                SELECT id INTO vDaten.DMS_BETRIEB_ID
                FROM dms_betrieb
                WHERE d0101_id = vD0101_id;

                EXCEPTION WHEN NO_DATA_FOUND THEN  -- bei skz<>1 mglich 
                  vDaten.DMS_BETRIEB_ID := NULL;       
              END;
                  
          END;
        ELSE
          vDaten.DMS_BETRIEB_ID := NULL;
        END IF; 
        
 
        
        IF vDaten.DMS_BETRIEB_ID IS NULL 
        AND NVL(vD0303.ref_obj, 'x') NOT IN ('VIS_D0114', 'VIS_D030502' ) -- Brgerbeschweden, Vergtung
        AND NVL(vD0303.dok_objekt_code, 'x') NOT IN ('1.08.05_2') THEN -- Weitere Ttigkeiten Eingenbehrde   
          pResult := 'Dokument ohne Betrieb wird nicht ans DMS exportiert (auer Brgerbeschwerden, Weitere Ttigkeiten Eingenbehrde und Vergtungen).';    
          CONTINUE; 
        END IF;
            
        vDaten.MANDANT := vD0303.mandant;
        vDaten.UPD_USER := BLV_SYS.GET_USER_SID;
        vDaten.UPD_DATE := vSYSDATE;
        vDaten.DELETED := 0;
        vDaten.DEL_USER := -1;
        vDaten.DEL_DATE := NULL;
        vDaten.Version_Update := vDaten.Version_Update + 1;
        vDaten.Date_Update := vSysdate;
        vDaten.d0101_id := vD0101_id;
        vDaten.d030301_id := vD030301_ID;
        vDaten.D0303_ID := pD0303_ID;
        vDaten.DOK_BEZ := vD0303.bez;
        vDaten.DOK_INS_DATE := vD0303.ins_date;  
        vDaten.REF_ID := vD0303.ref_id;
        vDaten.dok_objekt_code := vD0303.dok_objekt_code;
        vDaten.dok_objekt_bez := vD0303.dok_objekt_bez; 
                
        IF pErst = 1 THEN
          vDaten.version_export := -2;
        END IF;         
        
        IF vDaten.ref_id <> '-1' THEN

          IF vDaten.Dok_Objekt_Code IN( '1.08.04', '1.08.17' )
          OR vDaten.Dok_Objekt_Code LIKE '1.08.14%' THEN -- Probendaten
            BEGIN
              
              CASE vD0303.ref_obj 
              WHEN 'VIS_D010801' THEN
            
                SELECT PROBEN_ZEICHEN, BEZ
                INTO vDaten.PROBE_NR, vDaten.Probe_bez
                FROM vis_d0113
                WHERE d010801_id = vDaten.ref_id
                AND deleted = 0;
              
              WHEN 'VIS_D011301' THEN

                SELECT d0113.PROBEN_ZEICHEN, d0113.BEZ, d0113.d010801_id
                INTO vDaten.PROBE_NR, vDaten.Probe_bez, vDaten.ref_id
                FROM vis_d0113 d0113
                JOIN vis_d011301 d011301 ON d0113.id = d011301.d0113_id
                AND d011301.id = vDaten.ref_id
                AND d011301.deleted = 0
                AND d0113.deleted = 0;
                
              ELSE NULL;                            
              END CASE;
                
              EXCEPTION 
              WHEN no_data_found THEN NULL;
              WHEN too_many_rows THEN NULL;
            END;
          END IF;      
        
          IF vDaten.DMS_BETRIEB_ID IS NULL AND vD0101_ID <> '-1' THEN -- kein skz=1 Betrieb
            SELECT 
            dx.bez_komplett || ';' ||
            dx.plz || ';' ||
            TRIM(BOTH FROM dx.ort || ' ' || dx.ortsteil) || ';' ||
            dx.strasse_komplett          
            INTO vDaten.verantwortlicher 
            FROM vis_vd0101_adr dx
            WHERE dx.id = vD0101_id;                    
          END IF;
                
          CASE
       
          WHEN vD0303.ref_obj = 'VIS_D010102' THEN

             SELECT ax.bez INTO vDaten.art
             FROM vis_d010102 dx
             JOIN vis_a010145 ax ON ax.sid = dx.A010145_SID
             WHERE dx.id = vD0303.ref_id;
             
          WHEN vD0303.ref_obj = 'VIS_D010200' THEN  -- Personal
   
             SELECT d0102.nvname_komplett INTO vDaten.art
             FROM vis_d010200 dx
             JOIN vis_vd0102_adr d0102 ON d0102.id = dx.d0102_id
             WHERE dx.id = vD0303.ref_id;  
             
          WHEN vD0303.ref_obj = 'VIS_D0103' THEN  -- Abteilung

             SELECT ax.bez INTO vDaten.art
             FROM vis_d0103 dx
             JOIN vis_a0101 ax ON ax.sid = dx.A0101_47_SID
             WHERE dx.id = vD0303.ref_id;

          -- muss vor 1.08
          WHEN vDaten.Dok_Objekt_Code = '1.12' THEN  -- Impfungen

             SELECT d010801.fb, d010801.datum   
             , a010501.bez, d0102.nvname_komplett    
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010801 d010801    
             JOIN vis_a010501 a010501 ON d010801.a010501_01_sid = a010501.sid    
             JOIN vis_d010200 d010200 ON d010200.id = d010801.d010200_id    
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id
             WHERE d010801.id = vD0303.ref_id;                           

          WHEN vDaten.Dok_Objekt_Code = '1.11.01.2' THEN  -- Einzeltier-Impfungen
             
             SELECT d010801.fb, d010801.datum   
             , a010501.bez, d0102.nvname_komplett    
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010801 d010801    
             JOIN vis_d011101 d011101 ON d011101.d010801_id = d010801.id          
             JOIN vis_a010501 a010501 ON d010801.a010501_01_sid = a010501.sid    
             JOIN vis_d010200 d010200 ON d010200.id = d010801.d010200_id    
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id
             WHERE d011101.id = vD0303.ref_id;                           
                       
          WHEN vD0303.ref_obj = 'VIS_D0114' THEN  -- Brgerbeschwerden
          
             SELECT d0114.fb, d0114.datum, d0114.verantwortlicher, d0102.nvname_komplett, a0114.bez  
             INTO vFB, vDaten.datum, vDaten.verantwortlicher, vDaten.ueberwacher, vDaten.art
             FROM vis_d0114 d0114   
             JOIN vis_d010200 d010200 ON d0114.d010200_id = d010200.id
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id
             JOIN vis_a0114 a0114 ON a0114.sid = d0114.a0114_01_sid
             WHERE d0114.id = vD0303.ref_id;           
            
           vDaten.verantwortlicher := TRIM( BOTH ';' FROM 
              REGEXP_REPLACE(vDaten.verantwortlicher, '[[:cntrl:]]+', ';') );
             
          WHEN vD0303.ref_obj = 'VIS_D0115' THEN  -- Risikobeurteilung

             SELECT d0115.fb, d0115.datum, d0102.nvname_komplett, a0115.bez   
             INTO vFB, vDaten.datum, vDaten.ueberwacher, vDaten.art
             FROM vis_d0115 d0115
             JOIN vis_d010200 d010200 ON d0115.d010200_id = d010200.id
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id
             JOIN vis_a0115 a0115 ON a0115.sid = d0115.a0115_sid
             WHERE d0115.id = vD0303.ref_id;   

          WHEN vD0303.ref_obj = 'VIS_D0117' THEN  -- Milchhygienebefunde

             SELECT d0117.fb, d0117.datum, 'Milchhygienebefund' bez    
             INTO vFB, vDaten.datum, vDaten.art
             FROM vis_d0117 d0117    
             WHERE d0117.id = vD0303.ref_id;   

          WHEN vD0303.ref_obj = 'VIS_D0120' THEN  -- Sortiment

             SELECT ax.bez INTO vDaten.art
             FROM vis_d0120 dx
             JOIN vis_a011303 ax ON ax.sid = dx.A011303_01_SID
             WHERE dx.id = vD0303.ref_id;

          WHEN vD0303.ref_obj = 'VIS_D0122' THEN  -- tierseuchenrechtliche Bescheinigung

             SELECT dx.fb, dx.datum, ax.bez   
             INTO vFB, vDaten.datum, vDaten.art
             FROM vis_d0122 dx
             JOIN vis_a0122 ax ON ax.sid = dx.a0122_sid
             WHERE dx.id = vD0303.ref_id;   

          WHEN vD0303.ref_obj = 'VIS_D010803' THEN  -- Manahmen

             SELECT dx.fb, dx.datum, ax.bez, d0102.nvname_komplett
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010803 dx
             JOIN vis_d010200 d010200 ON dx.d010200_id = d010200.id
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id           
             JOIN vis_a010803 ax ON ax.sid = dx.a010803_01_sid
             WHERE dx.id = vD0303.ref_id;   

          WHEN vDaten.Dok_Objekt_Code = '3.05.10' THEN  -- Arbeitszeiterfassung

             SELECT dx.fb, dx.tag, ax.bez, d0102.nvname_komplett
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM VIS_D030510 dx
             JOIN vis_d010200 d010200 ON dx.d010200_id = d010200.id
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id           
             JOIN vis_a010801 ax ON ax.sid = dx.a010801_01_sid
             WHERE dx.id = vD0303.ref_id; 

          WHEN vDaten.Dok_Objekt_Code = '3.05.01' THEN  -- Gebhren

             SELECT dx.fb, dx.rdatum, TO_CHAR(dx.von, 'dd.mm.yyyy') || 
             CASE WHEN TRUNC(dx.von) <> trunc(dx.bis) THEN TO_CHAR(dx.bis, '-dd.mm.yyyy') END ||
             CASE WHEN dx.rdatum IS NOT NULL THEN TO_CHAR(dx.rdatum, ', dd.mm.yyyy') END 
             INTO vFB, vDaten.datum, vDaten.art
             FROM VIS_D030501 dx
             WHERE dx.id = vD0303.ref_id;
             
          WHEN vDaten.Dok_Objekt_Code = '3.05.02' THEN  -- Vergtung

             SELECT dx.fb, dx.bez, d0102.nvname_komplett
             INTO vFB, vDaten.art, vDaten.ueberwacher
             FROM VIS_D030502 dx
             JOIN vis_d010200 d010200 ON dx.d010200_id = d010200.id
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id           
             WHERE dx.id = vD0303.ref_id;       
  
          WHEN vDaten.dok_objekt_code = '1.08.05_2' THEN -- weitere Ttigkeiten Eigenbehrde  

             SELECT d010801.fb, d010801.datum, d010801.bez, d0102.nvname_komplett    
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010801 d010801    
             JOIN vis_d010200 d010200 ON d010200.id = d010801.d010200_id    
             JOIN vis_vd0102_adr d0102 ON d0102.id = d010200.d0102_id
             WHERE d010801.id = vD0303.ref_id;           

          WHEN vDaten.dok_objekt_code = '1.08' THEN -- Betriebsbesuch, sonstige Ttigkeiten 

             SELECT d010801.fb, d010801.datum, d010801.bez, d0102.nvname_komplett    
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010801 d010801    
             JOIN vis_d010200 d010200 ON d010200.id = d010801.d010200_id    
             JOIN VIS_VD0102_ADR d0102 ON d0102.id = d010200.d0102_id
             WHERE d010801.id = vD0303.ref_id;
           
          WHEN vD0303.ref_obj = 'VIS_D010801' 
          /*AND vDaten.Dok_Objekt_Code IN ( 
          
          '1.11', -- Untersuchungen
          '1.08' -- Betriebsbesuch, sonstige Ttigkeiten
          '1.08.01', -- Kontrollen (LM, Wein, FlHY, RE)
          '1.08.13', -- Kontrollen (TS, TSCH, TAM, TNP)
          '1.08.14', -- Probenahmen (FlHY, LM, TAM)
          '1.08.04', -- Probenahmen (LM, WEIN, FlHY)
          '1.08.14.00.01') -- Probenahmen FlHY 
          */
          THEN 
          
             SELECT d010801.fb, d010801.datum, a010801.bez, d0102.nvname_komplett    
             INTO vFB, vDaten.datum, vDaten.art, vDaten.ueberwacher
             FROM vis_d010801 d010801    
             JOIN vis_a010801 a010801 ON d010801.a010801_01_sid = a010801.sid    
             JOIN vis_d010200 d010200 ON d010200.id = d010801.d010200_id    
             JOIN VIS_VD0102_ADR d0102 ON d0102.id = d010200.d0102_id
             WHERE d010801.id = vD0303.ref_id;
                       
          WHEN vD0303.ref_obj <> '-1' AND vD0303.ref_id <> '-1' THEN
          
            DECLARE
            vExcep_942 EXCEPTION; -- Tabelle oder View nicht vorhanden
            vExcep_904 EXCEPTION; -- ungltiger Bezeichner
            vExcep_903 EXCEPTION; -- invalid table name
            
            PRAGMA EXCEPTION_INIT(vExcep_942,-942); 
            PRAGMA EXCEPTION_INIT(vExcep_904,-904); 
            PRAGMA EXCEPTION_INIT(vExcep_903,-903); 
            TYPE tRefCur IS REF CURSOR;
            vRefCur tRefCur; 
            vSQL VARCHAR2(500);   
            BEGIN

              vDaten.art := NULL;
              vDaten.ueberwacher := NULL;
        
              vSQL := 'SELECT dx.fb FROM ' || vD0303.ref_obj || ' dx ' ||
                      'WHERE dx.id = ''' || vD0303.ref_id || ''' '; 
            
              OPEN vRefCur FOR vSQL;
              FETCH vRefCur INTO vFB;
              CLOSE vRefCur;
          
            EXCEPTION 
            WHEN vExcep_942 OR vExcep_904 OR vExcep_903 THEN 
              vFB := NULL;
              vDaten.Datum := NULL;
              vDaten.art := NULL;
              vDaten.ueberwacher := NULL;
          
            END;
          
          ELSE
            vFB := NULL;
            vDaten.Datum := NULL;
            vDaten.art := NULL;
            vDaten.ueberwacher := NULL;                    
          END CASE;
        END IF;
        
        IF LENGTH(vFB) = 1 AND vFB <> '%' THEN
          vDaten.Dok_FB := vFB;
        ELSE
          -- resultierende FB aus S5200, D0101, S1711
          vDaten.Dok_FB := NULL;
          FOR c1 IN (
            SELECT SUBSTR( vFB, LEVEL, 1) AS fb
            FROM dual
            CONNECT BY SUBSTR( vFB, LEVEL, 1) IS NOT NULL
            
            INTERSECT
            SELECT SUBSTR( fb, LEVEL, 1)
            FROM ( SELECT d1.fb FROM vis_d0101 d1 WHERE d1.id = vD0101_id)
            CONNECT BY SUBSTR( fb, LEVEL, 1) IS NOT NULL
            
            INTERSECT
            SELECT SUBSTR( vD0303.S5200_fb, LEVEL, 1)
            FROM dual
            CONNECT BY SUBSTR( vD0303.S5200_fb, LEVEL, 1) IS NOT NULL
            
            INTERSECT
            SELECT SUBSTR( fb, LEVEL, 1)
            FROM ( SELECT d1.fb FROM vis_s1711 d1 WHERE d1.sid = vD0303.s1711_sid
            AND vD0303.s1711_sid > -1 )
            CONNECT BY SUBSTR( fb, LEVEL, 1) IS NOT NULL
            
          ) LOOP
            vDaten.Dok_FB := vDaten.Dok_FB || c1.fb; 
          END LOOP;
        END IF; 

        vDaten.dok_fb := BLVUTILS.GET_FB2KURZBV( vDaten.dok_fb );

        IF vDaten.ID = '-9999' THEN
          vDaten.ID := SYS_GUID();  
          INSERT INTO dms_daten VALUES vDaten;
        ELSE
          UPDATE dms_daten SET ROW = vDaten
          WHERE id = vDaten.id;
        END IF;      
      END LOOP;
    END IF; -- vD030301.COUNT > 0
  END IF; -- content_length
  COMMIT;
END Dokument;

PROCEDURE Dokument(pD0303_ID IN VARCHAR2) AS
v1 tVarcharMax;
BEGIN
  Dokument(pD0303_ID, v1, 0);
END Dokument;

FUNCTION Dokument(pD0303_ID IN VARCHAR2) RETURN VARCHAR AS
v1 tVarcharMax;
BEGIN
  Dokument(pD0303_ID, v1, 0);
  RETURN v1;
END Dokument;

PROCEDURE BetriebsakteErstbefuellung(pLimit IN INTEGER := 1000) AS 
  TYPE tD0101 IS RECORD ( ID vis_d0101.id%TYPE );
  TYPE tbD0101 IS TABLE OF tD0101;
  vD0101 tbD0101;
  CURSOR cD0101 IS 
    SELECT d0101.id
    FROM vis_d0101 d0101
    WHERE d0101.deleted = 0
    AND d0101.skz = 1
    AND d0101.mandant IN (
      SELECT s0702.mandant
      FROM VIS_S07 S07
      JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
      AND UPPER(S0701.CODE) LIKE 'DMSMODE'
      AND s0701.deleted = 0
      JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id
      AND s0702.deleted = 0
      AND s0702.wert = '1'
      AND S07.DELETED = 0 AND S07.CODE = 'DMS' )
    AND d0101.id NOT IN ( SELECT D0101_ID FROM dms_betrieb )
    ORDER BY d0101.code;

BEGIN

  IF pLimit > 0 THEN
    OPEN cD0101;
    FETCH cD0101 BULK COLLECT INTO vD0101 LIMIT pLimit;
    CLOSE cD0101;
  ELSE
    OPEN cD0101;
    FETCH cD0101 BULK COLLECT INTO vD0101;
    CLOSE cD0101;
  END IF;
  
  IF vD0101.COUNT > 0 THEN  
    FOR i IN vD0101.FIRST .. vD0101.LAST LOOP
      Betriebsakte( vD0101(i).ID, 1 );
    END LOOP;
  END IF;

END BetriebsakteErstbefuellung;


PROCEDURE DokumentErstbefuellung(pLimit IN INTEGER := 1000) AS 
  TYPE tD0303 IS RECORD ( ID tID32 );
  TYPE tbD0303 IS TABLE OF tD0303;
  vD0303 tbD0303;
  CURSOR cD0303 IS 
    SELECT d0303.id
    FROM vis_d0303 d0303
    WHERE d0303.deleted = 0
    AND (LENGTH(d0303.content) > 0 OR d0303.Filetype = 'SCAN')
    AND d0303.id IN ( SELECT d030301.d0303_id FROM vis_d030301 d030301 WHERE d030301.deleted = 0 )
    AND d0303.mandant IN (
      SELECT s0702.mandant
      FROM VIS_S07 S07
      JOIN vis_s0701 s0701 ON s0701.s07_id = s07.id
      AND UPPER(S0701.CODE) LIKE 'DMSMODE'
      AND s0701.deleted = 0
      JOIN vis_s0702 s0702 ON s0702.s0701_id = s0701.id
      AND s0702.deleted = 0
      AND s0702.wert = '1'
      AND S07.DELETED = 0 AND S07.CODE = 'DMS' )
    AND d0303.id NOT IN ( SELECT dx.D0303_ID FROM dms_daten dx )
    ORDER BY d0303.ins_date;
  v1 tVarcharMax;    
BEGIN

  IF pLimit > 0 THEN
    OPEN cD0303;
    FETCH cD0303 BULK COLLECT INTO vD0303 LIMIT pLimit;
    CLOSE cD0303;
  ELSE
    OPEN cD0303;
    FETCH cD0303 BULK COLLECT INTO vD0303;
    CLOSE cD0303;
  END IF;

  IF vD0303.COUNT > 0 THEN  
    FOR i IN vD0303.FIRST .. vD0303.LAST LOOP
      Dokument( vD0303(i).ID, v1, 1 );
    END LOOP;
  END IF;
END DokumentErstbefuellung;


/** 
  Ermittelt alle Betriebsakten und Dokumente in der richtigen Reihenfolge
  pErst : 1 - Erstbefllung
  Reihenfolge der Rckgabe
  1. 
**/
FUNCTION GetExportIDS(pErst IN PLS_INTEGER) RETURN tbExport PIPELINED AS
v1 tExport;
vDateFrmMsk CONSTANT VARCHAR2(25) := 'dd.mm.yyyy HH24:MI:SS'; -- 'yyyy.mm.dd HH24:MI:SS';
BEGIN
  IF pErst = 1 THEN  -- Erstbefllung
    FOR c1 IN (  
      SELECT dx.* FROM (
        SELECT d0101.ins_date ins_date, d0101.id, 'BET' obj
        , TO_CHAR(d0101.ins_date, vDateFrmMsk) || bet.d0101_id sort1
        , 1 sort2
        FROM dms_betrieb bet
        JOIN vis_d0101 d0101 ON d0101.id = bet.d0101_id
        AND BET.VERSION_EXPORT = -2  -- Betrieb in Erstbefllung
        UNION all
        SELECT dat.dok_ins_date, dat.id, 'DOK' obj
        , TO_CHAR(d0101.ins_date, vDateFrmMsk) || bet.d0101_id sort1
        , 2 sort2
        FROM dms_daten dat
        JOIN dms_betrieb bet ON bet.id = DAT.DMS_BETRIEB_ID
        JOIN vis_d0101 d0101 ON d0101.id = bet.d0101_id
        AND dat.VERSION_EXPORT = -2 -- Dok. in Erstbefllung, Betrieb egal
        UNION all
        SELECT dat.dok_ins_date, dat.id, 'DOK' obj
        , NULL sort1
        , 3 sort2
        FROM dms_daten dat
        LEFT JOIN dms_betrieb bet ON bet.id = DAT.DMS_BETRIEB_ID
        WHERE bet.id IS NULL                -- kein Betrieb zugeordnet
         AND dat.VERSION_EXPORT = -2 ) dx   -- Dok. in Erstbefllung
      ORDER BY sort1 NULLS LAST, sort2, ins_date
    ) LOOP
      
      v1.id := c1.id;
      v1.obj := c1.obj;
      v1.ins_date := c1.ins_date;
      PIPE ROW( v1 );  
    
    END LOOP;
  
  ELSE
  
    FOR c1 IN ( 
      SELECT dx.* FROM (     
        SELECT d0101.ins_date, bet1.d0101_id id, 'BET' obj
        , TO_CHAR(d0101.ins_date, vDateFrmMsk) || bet1.d0101_id sort1
        , 1 sort2
        FROM dms_betrieb bet1
        JOIN vis_d0101 d0101 ON d0101.id = bet1.d0101_id
        AND BET1.VERSION_EXPORT < bet1.version_update
        AND bet1.version_export > -2 - UID * 0  -- Betrieb nicht in Erstbefllung
        UNION all
        SELECT dat.dok_ins_date ins_date, dat.id, 'DOK' obj
        , TO_CHAR(d0101.ins_date, vDateFrmMsk) || bet.d0101_id sort1
        , 2 sort
        FROM dms_daten dat
        JOIN dms_betrieb bet ON bet.id = DAT.DMS_BETRIEB_ID
        JOIN vis_d0101 d0101 ON d0101.id = bet.d0101_id
        AND dat.VERSION_EXPORT < dat.version_update
        AND dat.version_export > -2 - UID * 0 -- Dok. nicht in Erstbefllung
        AND bet.version_export > -2           -- Betrieb nicht in Erstbefllung
        UNION all
        SELECT dat.dok_ins_date, dat.id, 'DOK' obj
        , NULL sort1
        , 3 sort2
        FROM dms_daten dat
        LEFT JOIN dms_betrieb bet ON bet.id = DAT.DMS_BETRIEB_ID
        WHERE bet.id IS NULL        -- kein Betrieb zugeordnet
        AND dat.VERSION_EXPORT > -2 -- Dok. nicht in Erstbefllung
        AND dat.VERSION_EXPORT < dat.version_update ) dx
      ORDER BY sort1 NULLS LAST, sort2, ins_date
    ) LOOP
      
      v1.id := c1.id;
      v1.obj := c1.obj;
      v1.ins_date := c1.ins_date;
      PIPE ROW( v1 );  
    
    END LOOP;

  END IF;
  RETURN;
END GetExportIDS;

END blv_dms;
/
/* Komplette Erstbefllung simulieren
create or replace procedure test as
--DECLARE
  vExport blv_dms.tbExport;
  vBet blv_dms.tDMS_Betrieb := NULL;
  vDok blv_dms.tDokument := NULL;
  iBet pls_integer := 0;
  iDok pls_integer := 0;
  v1 pls_integer;
  
  PROCEDURE BetConfirm AS
  BEGIN
    IF vBet.id IS NOT NULL THEN
      v1 := blv_dms.BetriebsakteConfirm( vBet.d0101_id, vBet.version_update , 'dms_'||iBet ); 
      commit;       
      vBet := NULL;
      vBet.ID := NULL;
    END IF;  
  END;
  
BEGIN
  vBet.ID := NULL;
  
  SELECT dx.* BULK COLLECT INTO vExport
  FROM TABLE( blv_dms.GetExportIDs(1) ) dx
  where dx.id in (  
   '9253A9AFFD654EF79E18108FE6FCBF4E',  
   '25AD0EC0B18F4965863247E71219E082',  
   'F2F4F012072E4F709C2FBAE9DE44CA84',  
   '628D885E7D8848A5AAE2DAE2D08D1FAB');
  
  IF vExport.COUNT > 0 THEN
    FOR iExportID IN vExport.FIRST .. vExport.LAST LOOP
      -- Confirm Betriebsakte
      IF vExport(iExportID).obj = 'BET' THEN
        BetConfirm();
      END IF;
       
      CASE vExport(iExportID).obj
      WHEN 'BET' THEN
      
        SELECT bet.* INTO vBet
        FROM TABLE( blv_dms.BetriebsakteExport( vExport(iExportID).id  ) ) bet;      
        -- > DMS Export Betriebsakte, Besttigung fr spter merken
        iBet := iBet + 1;  -- simulierte Besttigung vom DMS
        
      WHEN 'DOK' THEN
      
        SELECT dok.* INTO vDok
        FROM TABLE( blv_dms.DokumentExport( vExport(iExportID).id ) ) dok;
        
        -- > DMS Export
        -- Besttigung
        iDok := iDok + 1; -- simulierte Besttigung vom DMS
        v1 := blv_dms.DokumentConfirm(vExport(iExportID).id, vDok.version_update, 'dms_'||iDok );
        commit;
      --ELSE NULL;
      END CASE;   

    
    END LOOP;
    BetConfirm(); -- Besttigung letzte Betriebsakte
  END IF;
DBMS_OUTPUT.PUT_LINE('iBet:'||iBet);
DBMS_OUTPUT.PUT_LINE('iDok:'||iDok);  
END; *//*<TOAD_FILE_CHUNK>*/
/*
Trigger fr DMS_Betrieb
Tabellen:
- vis_d0101 (vis_vd0101_adr)
  fachb
  code
  bez_komplett
  strasse_komplett
  plz, ort, ortsteil
  anmeldung
  abmeldung
  d0101.bez (d0101.d0101_id3)
- vis_d010200  
  bez aktualisieren in dms_betrieb.d0101_id (VIS_D0101.D010200_id2)
 
*/


CREATE OR REPLACE TRIGGER TRG_DMS_BETRIEB_D0101
AFTER INSERT OR UPDATE 
OF fachb, bez, name1, code
, plz, ort, ortsteil, strasse, hausnr, hausnrzusatz 
, anmeldung, abmeldung, deleted, d010200_id2
ON VIS_D0101
FOR EACH ROW
WHEN (NEW.skz = 1)
DECLARE 
  vSYSDATE DATE := SYSDATE;
  vUser_SID INTEGER :=  BLV_SYS.GET_USER_SID;
  vStr dms_betrieb.betrieb_str%TYPE;
  vOrt dms_betrieb.betrieb_ort%TYPE;
  vBez dms_betrieb.betrieb_bez%TYPE;
  vAbmeldung dms_betrieb.betrieb_abmeldung%TYPE;
BEGIN
    
  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN

    vStr := TRIM (:NEW.strasse || ' ' || TRIM (:NEW.hausnr || ' ' || :NEW.hausnrzusatz));
    vOrt := RTRIM(:NEW.plz || ' ' || :NEW.ort || ' ' || :NEW.ortsteil);
    vBez := :NEW.bez || 
            CASE WHEN :NEW.bez IS NOT NULL AND :NEW.name1 IS NOT NULL THEN ' / '
            END || :NEW.name1;

    IF :NEW.deleted = 0 THEN
      vAbmeldung := :NEW.Abmeldung;
    ELSE
      vABmeldung := :NEW.Del_Date;
    END IF;
            
    MERGE INTO dms_betrieb bts
    USING ( SELECT :NEW.ID id FROM dual) dx
    ON ( dx.id = bts.d0101_id )
    WHEN NOT MATCHED THEN INSERT (
      ins_user, ins_date, d0101_id, Mandant,
      upd_user, upd_date, deleted, del_user, del_date,
      betrieb_fb, betrieb_bez, betrieb_nr,
      betrieb_str, betrieb_ort,
      betrieb_anmeldung, betrieb_abmeldung, betreiber )  
    VALUES (
      vUSER_SID, vSysdate, :NEW.ID, :NEW.MANDANT,
      vUser_SID, vSysdate, 0, -1, NULL,
      :NEW.FACHB, vBez, :NEW.Code,
      vStr, vOrt,
      :NEW.Anmeldung, vAbmeldung, :NEW.bez)
    WHEN MATCHED THEN UPDATE SET
      bts.upd_user = vUser_SID, 
      bts.betrieb_fb = :NEW.fachb,
      bts.betrieb_bez = vBez,
      bts.betrieb_nr = :NEW.CODE,
      bts.betrieb_str = vStr,
      bts.betrieb_ort = vOrt,
      bts.betrieb_anmeldung = :NEW.Anmeldung,
      bts.Betrieb_Abmeldung = vAbmeldung,
      bts.betreiber = :NEW.bez,
      bts.version_update = bts.version_update + 1,
      bts.date_update = vSysdate;  
    
    -- anderen Hauptverantwortlichen zugeordnet bzw. bei Anlage vorhanden
    IF (INSERTING AND :NEW.D010200_ID2 <> '-1') OR :OLD.D010200_ID2 <> :NEW.D010200_ID2 THEN
      UPDATE dms_betrieb
      SET version_update = version_update + 1
        , date_update = vSysdate
        , betrieb_hauptverantwortlicher = ( 
            SELECT NVL(d010200.bez, d0102.bez) 
            FROM vis_d010200 d010200
            JOIN vis_d0102 d0102 ON d0102.id = d010200.d0102_id 
            WHERE d010200.id = :NEW.d010200_ID2 ) 
      WHERE d0101_id = :NEW.id;  
    END IF;   
    
  END IF; -- blv_dms.ChkMandantDms          
END;
/

/*
- vis_d010101
  bez fr skz=2, hauptn=1 -> BETRIEB_LM_HAUPT_BA
  bez fr skz=2, fb like '%H%' -> BETRIEB_LM_BA
  bez fr skz=1, fb like '%D%' -> BETRIEB_TS_BA
*/  
CREATE OR REPLACE TRIGGER TRG_DMS_BETRIEB_D010101
AFTER INSERT OR UPDATE 
OF a010108_sid, deleted, del_date 
, angemeldet, abgemeldet, hauptn
ON VIS_D010101
FOR EACH ROW
DECLARE vSYSDATE DATE := SYSDATE;
BEGIN
-- funktioniert nicht  blv_dms.BetriebsakteTrigger(:NEW.D0101_ID);    
  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN
    IF ( :NEW.A010108_skz = 2 AND :NEW.FB LIKE '%H%') OR
    (:NEW.a010108_skz = 1 AND :NEW.FB LIKE '%D%') THEN     
      UPDATE dms_betrieb
      SET version_update = version_update + 1
        , date_update = vSysdate
      WHERE d0101_id = :NEW.d0101_id;
    END IF;
  END IF; -- blv_dms.ChkMandantDms
END TRG_DMS_BETRIEB_D010101;
/

/*
- vis_d010102
  nummer fr code = '0103*', skz = 60, kz = 'Z' -> BETRIEB_ZUL_FLHYG
  nummer fr code = '0102', skz = 10, -> BETRIEB_HIT_NR
*/  
CREATE OR REPLACE TRIGGER TRG_DMS_BETRIEB_D010102
AFTER INSERT OR UPDATE 
OF nummer, a010145_sid, deleted, del_date 
, gueltig_von, gueltig_bis
ON VIS_D010102
FOR EACH ROW
DECLARE
  TYPE t1 IS RECORD ( 
    code vis_a010145.code%TYPE, 
    skz vis_a010145.skz%TYPE, 
    kz vis_a010145.kz%TYPE);
  v1 t1;    
  vSYSDATE DATE := SYSDATE; 
BEGIN

  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN

    SELECT a010145.code, a010145.skz, a010145.kz
    INTO v1
    FROM vis_a010145 a010145
    WHERE sid = :NEW.A010145_SID;
    
    IF ((v1.code LIKE '0103%' OR v1.code LIKE '010111%') AND v1.skz = 60 AND v1.kz = 'Z') OR
    (v1.code LIKE '0102' AND v1.SKZ = 10) THEN
      UPDATE dms_betrieb
      SET version_update = version_update + 1 
        , date_update = vSysdate
      WHERE d0101_id = :NEW.d0101_id;   
    END IF;
  END IF; -- blv_dms.ChkMandantDms
  
END TRG_DMS_BETRIEB_D010102;
/

/*
drop TRIGGER TRG_DMS_BETRIEB_D010200
CREATE OR REPLACE TRIGGER TRG_DMS_BETRIEB_D010200
AFTER INSERT OR UPDATE
OF bez, deleted
ON vis_d010200
FOR EACH ROW
BEGIN

  IF :NEW.deleted = 0 THEN  
    UPDATE ( 
      SELECT d1.BETRIEB_HAUPTVERANTWORTLICHER, d1.version_update 
      FROM vis_d0101 d0101
      JOIN dms_betrieb d1 ON d1.d0101_id = d0101.id
      AND d0101.d010200_id2 = :NEW.ID ) dx
    SET BETRIEB_HAUPTVERANTWORTLICHER = :NEW.bez
      , version_update = version_update + 1 ;
  ELSE -- gelscht
    UPDATE ( 
      SELECT d1.BETRIEB_HAUPTVERANTWORTLICHER, d1.version_update 
      FROM vis_d0101 d0101
      JOIN dms_betrieb d1 ON d1.d0101_id = d0101.id
      AND d0101.d010200_id2 = :NEW.ID ) dx
    SET BETRIEB_HAUPTVERANTWORTLICHER = NULL
      , version_update = version_update + 1 ;
  END IF;

END; 
/ */


-- 18.12.2014 wird jetzt beim Export verarbeitet
--DECLARE 
--vExcep_4080 EXCEPTION;
--PRAGMA EXCEPTION_INIT(vExcep_4080,-4080);
--BEGIN
--  EXECUTE IMMEDIATE 'DROP TRIGGER TRG_DMS_BETRIEB_D0102';
--  EXCEPTION WHEN vExcep_4080 THEN NULL;
--END;
--/

CREATE OR REPLACE TRIGGER TRG_DMS_BETRIEB_D0102
AFTER INSERT OR UPDATE
OF bez, deleted
ON vis_d0102
FOR EACH ROW
DECLARE vSYSDATE DATE := SYSDATE;
BEGIN
  
  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN
  
    IF :NEW.deleted = 0 THEN  
      UPDATE ( 
        SELECT d1.BETRIEB_HAUPTVERANTWORTLICHER, d1.version_update, d1.date_update
        FROM vis_d010200 d010200 
        JOIN vis_d0101 d0101 ON d0101.d010200_id2 = d010200.id
        JOIN dms_betrieb d1 ON d1.d0101_id = d0101.id
        WHERE d010200.d0102_id = :NEW.ID ) dx
      SET BETRIEB_HAUPTVERANTWORTLICHER = :NEW.bez
        , version_update = version_update + 1 
        , date_update = vSysdate;
    ELSE -- gelscht
      UPDATE ( 
        SELECT d1.BETRIEB_HAUPTVERANTWORTLICHER, d1.version_update, d1.date_update
        FROM vis_d010200 d010200 
        JOIN vis_d0101 d0101 ON d0101.d010200_id2 = d010200.id
        JOIN dms_betrieb d1 ON d1.d0101_id = d0101.id
        WHERE d010200.d0102_id = :NEW.ID ) dx
      SET BETRIEB_HAUPTVERANTWORTLICHER = NULL
        , version_update = version_update + 1
        , date_update = vSysdate;
    END IF;
  
  END IF; -- blv_dms.ChkMandantDms
END;
/

CREATE OR REPLACE TRIGGER TRG_DMS_DATEN_D0303
AFTER UPDATE
OF deleted
ON vis_d0303
FOR EACH ROW
WHEN ( NEW.DELETED <> OLD.DELETED )
DECLARE vSYSDATE DATE := SYSDATE;
BEGIN
  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN
 
    UPDATE dms_daten
    SET deleted = :NEW.deleted
      , version_update = version_update + 1 
      , date_update = vSysdate
    WHERE d0303_id = :NEW.ID;
  
  END IF; -- blv_dms.ChkMandantDms
END;
/

CREATE OR REPLACE TRIGGER TRG_DMS_DATEN_D030301
AFTER UPDATE
OF deleted
ON vis_d030301
FOR EACH ROW
WHEN ( NEW.DELETED <> OLD.DELETED )
DECLARE vSYSDATE DATE := SYSDATE;
BEGIN
  IF blv_dms.ChkMandantDms(:NEW.MANDANT) > 0 THEN
 
    UPDATE dms_daten
    SET deleted = :NEW.deleted
      , del_date = :NEW.DEL_DATE
      , del_user = :NEW.DEL_USER
      , version_update = version_update + 1 
      , date_update = vSysdate
    WHERE d030301_id = :NEW.ID;
  
  END IF; -- blv_dms.ChkMandantDms
END;
/

