/*******************************************************************************
 Skript mit Strukturupdates fr den BALVI Schnittstellenserver 3.3.x
 
 SVN Revisionsinformationen
 $Revision: 415 $
 
*******************************************************************************/
/*
ALTER SESSION SET NLS_TERRITORY = 'GERMANY';
ALTER SESSION SET NLS_DATE_LANGUAGE = 'GERMAN';
ALTER SESSION SET NLS_LANGUAGE = 'GERMAN';
ALTER SESSION SET NLS_SORT = 'GERMAN';
ALTER SESSION SET NLS_CALENDAR = 'GREGORIAN';
ALTER SESSION SET NLS_NUMERIC_CHARACTERS = ',.';
ALTER SESSION SET NLS_DATE_FORMAT = 'dd.mm.yyyy';
ALTER SESSION SET NLS_LENGTH_SEMANTICS = CHAR;
--ALTER SESSION SET NLS_COMP = ANSI;
*/

-------------------------------------------------------------------------------
DECLARE 
  vCnt INT;
  vIDX_TBS VARCHAR2(50) := NULL; 
  vUI_TBS VARCHAR2(60) := NULL; 
  vS00_DB_Version vis_s00.db_version%TYPE;
  vDB_Version CONSTANT VARCHAR2(10) := '1.24.000';
        
  FUNCTION FieldExists(pTable_name IN VARCHAR2, pColumn_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tab_columns
    WHERE table_name = pTable_name
      AND column_name = pColumn_name;
      
    RETURN vCnt > 0; 
  
  END;

  FUNCTION TableExists(pTable_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tables
    WHERE table_name = pTable_name;
      
    RETURN vCnt > 0; 
  
  END;

  PROCEDURE DropView(pView_name IN VARCHAR2) AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_views
    WHERE view_name = pView_name;
      
    IF vCnt > 0 THEN
      EXECUTE IMMEDIATE 'DROP VIEW ' || pView_name;
    END IF; 
  
  END;
    
  FUNCTION IdxExists(pIndex_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_indexes
    WHERE index_name = pIndex_Name;
      
    RETURN vCnt > 0; 
  
  END;  
  
  PROCEDURE CrtIdx(pSQL IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE pSQL || vIDX_TBS;
  END;  

  FUNCTION ConstraintExists(pConstraint_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_constraints
    WHERE constraint_name = pConstraint_name;
      
    RETURN vCnt > 0; 
  
  END;
   

  PROCEDURE COMMENT_COL(pTab_Col IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON COLUMN ' || pTab_Col || ' IS ''' || pComment || '''';  
  END;
  
  PROCEDURE COMMENT_TAB(pTab IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON TABLE ' || pTab || ' IS ''' || pComment || '''';  
  END;

BEGIN
  /* BODY */
  -- Immer setzen, falls bei VARCHAR() nicht explizit angegeben
  EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_LENGTH_SEMANTICS = CHAR';

  -- Index-Tablespace merken
  SELECT tablespace_name INTO vIDX_TBS
  FROM user_indexes
  WHERE index_name = 'PK_D0101_ID';
  
  IF vIDX_TBS IS NOT NULL THEN
    vIDX_TBS := ' TABLESPACE ' || vIDX_TBS;
    vUI_TBS := ' USING INDEX ' || vIDX_TBS;
  END IF;
	
	-- FB, 20.09.2017: gem. JIRA BSS-155 
	IF NOT FieldExists('JOB_DEF', 'INVOKE_BY_SERVICE') THEN
    EXECUTE IMMEDIATE q'[ALTER TABLE JOB_DEF ADD INVOKE_BY_SERVICE NUMBER(1,0) DEFAULT 0 NOT NULL]';
      
    COMMENT_COL('JOB_DEF.INVOKE_BY_SERVICE', 'Dieser Job darf von Auen ber SOAP angesprochen werden (Boolean) 0 = Nein / Default ,1 = Ja');  
  
  END IF;
  
END;
/

-- EOF