-- zu Update 1.22d an alle Kunden raus 

/******************************************************************************

  Strukturanpassung Kommunikationsserver 2.6
  
******************************************************************************/

DECLARE 
  vCnt INT;
  vIDX_TBS VARCHAR2(50) := NULL; 
  vUI_TBS VARCHAR2(60) := NULL; 
        
  FUNCTION FieldExists(pTable_name IN VARCHAR2, pColumn_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tab_columns
    WHERE table_name = pTable_name
      AND column_name = pColumn_name;
      
    RETURN vCnt > 0; 
  
  END;

  FUNCTION TableExists(pTable_name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_tables
    WHERE table_name = pTable_name;
      
    RETURN vCnt > 0; 
  
  END;
  
  FUNCTION IdxExists(pIndex_Name IN VARCHAR2) RETURN BOOLEAN AS
  BEGIN

    SELECT COUNT(*) INTO vCnt
    FROM user_indexes
    WHERE index_name = pIndex_Name;
      
    RETURN vCnt > 0; 
  
  END;  

  PROCEDURE COMMENT_COL(pTab_Col IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON COLUMN ' || pTab_Col || ' IS ''' || pComment || '''';  
  END;
  
  PROCEDURE COMMENT_TAB(pTab IN VARCHAR2, pComment IN VARCHAR2) AS
  BEGIN
    EXECUTE IMMEDIATE 'COMMENT ON TABLE ' || pTab || ' IS ''' || pComment || '''';  
  END;
             
BEGIN
  -- Index-Tablespace merken
  SELECT tablespace_name INTO vIDX_TBS
  FROM user_indexes
  WHERE index_name = 'PK_D0101_ID';
  
  IF vIDX_TBS IS NOT NULL THEN
    vIDX_TBS := ' TABLESPACE ' || vIDX_TBS;
    vUI_TBS := ' USING INDEX ' || vIDX_TBS;
  END IF;
  
  IF NOT FieldExists('XML_IMP_DEF', 'FILE_REPOS_POST_SCRIPT_ID') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_IMP_DEF ADD ( FILE_REPOS_POST_SCRIPT_ID VARCHAR2(32) DEFAULT ''-1'' NOT NULL )';
  END IF;
  
  IF NOT FieldExists('XML_IMP_DEF', 'SERVER_VERSIONS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_IMP_DEF ADD ( SERVER_VERSIONS VARCHAR2(64) DEFAULT ''* - *'' NOT NULL)';
  END IF;
  
  IF NOT FieldExists('XML_EXP_DEF', 'SERVER_VERSIONS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE XML_EXP_DEF ADD ( SERVER_VERSIONS VARCHAR2(64) DEFAULT ''* - *'' NOT NULL)';
  END IF;
  
  IF NOT FieldExists('JOB_DEF', 'SERVER_VERSIONS') THEN  
    EXECUTE IMMEDIATE 'ALTER TABLE JOB_DEF ADD ( SERVER_VERSIONS VARCHAR2(64) DEFAULT ''* - *'' NOT NULL)';
  END IF;
  
END;
/

